## gnuradio 3.5.1

=== gr-noaa/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
# 
# This file is part of GNU Radio
# 
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup dependencies
########################################################################
include(GrBoost)

########################################################################
# Register component
########################################################################
include(GrComponent)
GR_REGISTER_COMPONENT("gr-noaa" ENABLE_GR_NOAA
    Boost_FOUND
    ENABLE_GR_CORE
)

GR_SET_GLOBAL(GR_NOAA_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/lib
)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_NOAA)

########################################################################
# Setup CPack components
########################################################################
include(GrPackage)
CPACK_SET(CPACK_COMPONENT_GROUP_NOAA_DESCRIPTION "GNU Radio NOAA Blocks")

CPACK_COMPONENT("noaa_runtime"
    GROUP        "NOAA"
    DISPLAY_NAME "Runtime"
    DESCRIPTION  "Runtime"
    DEPENDS      "core_runtime"
)

CPACK_COMPONENT("noaa_devel"
    GROUP        "NOAA"
    DISPLAY_NAME "Development"
    DESCRIPTION  "C++ headers, package config, import libraries"
    DEPENDS      "core_devel"
)

CPACK_COMPONENT("noaa_python"
    GROUP        "NOAA"
    DISPLAY_NAME "Python"
    DESCRIPTION  "Python modules for runtime; GRC xml files"
    DEPENDS      "core_python;noaa_runtime"
)

CPACK_COMPONENT("noaa_swig"
    GROUP        "NOAA"
    DISPLAY_NAME "SWIG"
    DESCRIPTION  "SWIG development .i files"
    DEPENDS      "core_swig;noaa_python;noaa_devel"
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(lib)
if(ENABLE_PYTHON)
    add_subdirectory(swig)
    add_subdirectory(grc)
    add_subdirectory(apps)
endif(ENABLE_PYTHON)

endif(ENABLE_GR_NOAA)

=== gr-shd/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
# 
# This file is part of GNU Radio
# 
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup dependencies
########################################################################
include(GrBoost)

PKG_CHECK_MODULES(PC_SHD shd QUIET)
FIND_PATH(
    SHD_INCLUDE_DIRS
    NAMES shd/config.hpp
    HINTS $ENV{SHD_DIR}/include
        ${PC_SHD_INCLUDE_DIRS}
    PATHS /usr/local/include
          /usr/include
)

FIND_LIBRARY(
    SHD_LIBRARIES
    NAMES shd
    HINTS $ENV{SHD_DIR}/lib
        ${PC_SHD_LIBRARIES}
    PATHS /usr/local/lib
          /usr/lib
)

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(SHD DEFAULT_MSG SHD_LIBRARIES SHD_INCLUDE_DIRS)
MARK_AS_ADVANCED(SHD_LIBRARIES SHD_INCLUDE_DIRS)

########################################################################
# Register component
########################################################################
include(GrComponent)
GR_REGISTER_COMPONENT("gr-shd" ENABLE_GR_SHD
    Boost_FOUND
    SHD_FOUND
    ENABLE_GR_CORE
)

GR_SET_GLOBAL(GR_SHD_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${SHD_INCLUDE_DIRS}
)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_SHD)

########################################################################
# Setup CPack components
########################################################################
include(GrPackage)
CPACK_SET(CPACK_COMPONENT_GROUP_SHD_DESCRIPTION "GNU Radio SHD Blocks")

CPACK_COMPONENT("shd_runtime"
    GROUP        "SHD"
    DISPLAY_NAME "Runtime"
    DESCRIPTION  "Runtime"
    DEPENDS      "core_runtime"
)

CPACK_COMPONENT("shd_devel"
    GROUP        "SHD"
    DISPLAY_NAME "Development"
    DESCRIPTION  "C++ headers, package config, import libraries"
    DEPENDS      "core_devel"
)

CPACK_COMPONENT("shd_python"
    GROUP        "SHD"
    DISPLAY_NAME "Python"
    DESCRIPTION  "Python modules for runtime; GRC xml files"
    DEPENDS      "core_python;shd_runtime"
)

CPACK_COMPONENT("shd_swig"
    GROUP        "SHD"
    DISPLAY_NAME "SWIG"
    DESCRIPTION  "SWIG development .i files"
    DEPENDS      "core_swig;shd_python;shd_devel"
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include)
add_subdirectory(lib)
if(ENABLE_PYTHON)
    add_subdirectory(swig)
    add_subdirectory(grc)
    add_subdirectory(apps)
endif(ENABLE_PYTHON)

########################################################################
# Create Pkg Config File
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-shd.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-shd.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-shd.pc
    DESTINATION ${GR_LIBRARY_DIR}/pkgconfig
    COMPONENT "shd_devel"
)

endif(ENABLE_GR_SHD)

=== gr-vocoder/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
# 
# This file is part of GNU Radio
# 
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup dependencies
########################################################################
include(GrBoost)

########################################################################
# Register component
########################################################################
include(GrComponent)
GR_REGISTER_COMPONENT("gr-vocoder" ENABLE_GR_VOCODER
    Boost_FOUND
    ENABLE_GR_CORE
)

GR_SET_GLOBAL(GR_VOCODER_INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/include
)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_VOCODER)

########################################################################
# Setup CPack components
########################################################################
include(GrPackage)
CPACK_SET(CPACK_COMPONENT_GROUP_VOCODER_DESCRIPTION "GNU Radio Vocoder Blocks")

CPACK_COMPONENT("vocoder_runtime"
    GROUP        "Vocoder"
    DISPLAY_NAME "Runtime"
    DESCRIPTION  "Dynamic link libraries"
    DEPENDS      "core_runtime"
)

CPACK_COMPONENT("vocoder_devel"
    GROUP        "Vocoder"
    DISPLAY_NAME "Development"
    DESCRIPTION  "C++ headers, package config, import libraries"
    DEPENDS      "core_devel"
)

CPACK_COMPONENT("vocoder_python"
    GROUP        "Vocoder"
    DISPLAY_NAME "Python"
    DESCRIPTION  "Python modules for runtime"
    DEPENDS      "core_python;vocoder_runtime"
)

CPACK_COMPONENT("vocoder_examples"
    GROUP        "Vocoder"
    DISPLAY_NAME "Examples"
    DESCRIPTION  "Python examples for vocoder"
    DEPENDS      "vocoder_python"
)

CPACK_COMPONENT("vocoder_swig"
    GROUP        "Vocoder"
    DISPLAY_NAME "SWIG"
    DESCRIPTION  "SWIG development .i files"
    DEPENDS      "core_swig;vocoder_python;vocoder_devel"
)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(lib)
add_subdirectory(include)
add_subdirectory(doc)
if(ENABLE_PYTHON)
    add_subdirectory(swig)
    add_subdirectory(python)
    add_subdirectory(examples)
endif(ENABLE_PYTHON)

########################################################################
# Create Pkg Config File
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-vocoder.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-vocoder.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-vocoder.pc
    DESTINATION ${GR_LIBRARY_DIR}/pkgconfig
    COMPONENT "vocoder_devel"
)

endif(ENABLE_GR_VOCODER)

=== gr-digital/examples/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

include(GrPython)

GR_PYTHON_INSTALL(PROGRAMS
    example_costas.py
    example_fll.py
    example_timing.py
    run_length.py
    gen_whitener.py
    snr_estimators.py
    DESTINATION ${GR_PKG_DATA_DIR}/examples/digital
    COMPONENT "digital_python"
)

GR_PYTHON_INSTALL(PROGRAMS
    narrowband/transmit_path.py
    narrowband/receive_path.py
    narrowband/uhd_interface.py
    narrowband/benchmark_tx.py
    narrowband/benchmark_rx.py
    narrowband/tx_voice.py
    narrowband/rx_voice.py
    narrowband/digital_bert_rx.py
    narrowband/digital_bert_tx.py
    narrowband/tunnel.py
    DESTINATION ${GR_PKG_DATA_DIR}/examples/digital/narrowband
    COMPONENT "digital_python"
)

=== gr-digital/grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

install(FILES
    digital_block_tree.xml
    digital_binary_slicer_fb.xml
    digital_clock_recovery_mm_xx.xml
    digital_constellation_decoder_cb.xml
    digital_correlate_access_code_bb.xml
    digital_costas_loop_cc.xml
    digital_cma_equalizer_cc.xml
    digital_cpmmod_bc.xml
    digital_fll_band_edge_cc.xml
    digital_gmsk_demod.xml
    digital_gmsk_mod.xml
    digital_gmskmod_bc.xml
    digital_kurtotic_equalizer_cc.xml
    digital_lms_dd_equalizer_cc.xml
    digital_mpsk_receiver_cc.xml
    digital_dxpsk_mod.xml
    digital_dxpsk_demod.xml
    digital_psk_mod.xml
    digital_psk_demod.xml
    digital_qam_mod.xml
    digital_qam_demod.xml
    digital_ofdm_mod.xml
    digital_ofdm_demod.xml
    digital_ofdm_cyclic_prefixer.xml
    digital_ofdm_frame_acquisition.xml
    digital_ofdm_insert_preamble.xml
    digital_ofdm_sampler.xml
    digital_ofdm_sync_pn.xml
    DESTINATION ${GRC_BLOCKS_DIR}
    COMPONENT "digital_python"
)

=== gr-howto-write-a-block-cmake/swig/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Include swig generation macros
########################################################################
find_package(SWIG)
find_package(PythonLibs)
if(NOT SWIG_FOUND OR NOT PYTHONLIBS_FOUND)
    return()
endif()
include(GrSwig)
include(GrPython)

########################################################################
# Setup swig generation
########################################################################
foreach(incdir ${GNURADIO_CORE_INCLUDE_DIRS})
    list(APPEND GR_SWIG_INCLUDE_DIRS ${incdir}/swig)
endforeach(incdir)

set(GR_SWIG_LIBRARIES gnuradio-howto)
set(GR_SWIG_DOC_FILE ${CMAKE_CURRENT_BINARY_DIR}/howto_swig_doc.i)
set(GR_SWIG_DOC_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../include)

GR_SWIG_MAKE(howto_swig howto_swig.i)

########################################################################
# Install the build swig module
########################################################################
GR_SWIG_INSTALL(TARGETS howto_swig DESTINATION ${GR_PYTHON_DIR}/howto)

########################################################################
# Install swig .i files for development
########################################################################
install(
    FILES
    howto_swig.i
    ${CMAKE_CURRENT_BINARY_DIR}/howto_swig_doc.i
    DESTINATION $(GR_INCLUDE_DIR)/howto/swig
)

=== grc/freedesktop/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
# 
# This file is part of GNU Radio
# 
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
set(grc_freedesktop_path ${GR_PKG_DATA_DIR}/grc/freedesktop)

install(FILES
    grc-icon-256.png
    grc-icon-128.png
    grc-icon-64.png
    grc-icon-48.png
    grc-icon-32.png
    gnuradio-grc.xml
    gnuradio-grc.desktop
    DESTINATION ${grc_freedesktop_path}
    COMPONENT "grc"
)

find_program(HAVE_XDG_UTILS xdg-desktop-menu)

if(UNIX AND HAVE_XDG_UTILS)
    set(SRCDIR ${CMAKE_INSTALL_PREFIX}/${grc_freedesktop_path})
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/grc_setup_freedesktop.in
        ${CMAKE_CURRENT_BINARY_DIR}/grc_setup_freedesktop
    @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/grc_setup_freedesktop
        DESTINATION ${GR_PKG_LIBEXEC_DIR} COMPONENT "grc"
    )
endif(UNIX AND HAVE_XDG_UTILS)

=== volk/apps/CMakeLists.txt ===
#
# Copyright 2011 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

########################################################################
# Setup profiler
########################################################################
find_package(Boost)

if(Boost_FOUND AND UNIX) #uses mkdir and $HOME

if(MSVC)
    include_directories(${CMAKE_SOURCE_DIR}/msvc)
endif(MSVC)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
)

add_executable(volk_profile
    ${CMAKE_CURRENT_SOURCE_DIR}/volk_profile.cc
    ${CMAKE_SOURCE_DIR}/lib/qa_utils.cc
)

target_link_libraries(volk_profile volk ${Boost_LIBRARIES})

endif(Boost_FOUND AND UNIX)

=== volk/lib/CMakeLists.txt ===
#
# Copyright 2011 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

########################################################################
# Setup the compiler name
########################################################################
set(COMPILER_NAME ${CMAKE_C_COMPILER_ID})
if(MSVC) #its not set otherwise
    set(COMPILER_NAME MSVC)
endif()

if(NOT DEFINED COMPILER_NAME)
    message(FATAL_ERROR "COMPILER_NAME undefined. Volk build may not support this compiler.")
endif()

########################################################################
# Parse the arches xml file:
#  Test each arch to see if the compiler supports the flag.
#  If the test passes append the arch to the available list.
########################################################################
#extract the compiler lines from the xml file using abusive python



execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c
    "from xml.dom import minidom; print ';'.join(map(lambda b: ','.join([','.join([b.attributes['name'].value,item.attributes['name'].value,item.firstChild.data]) for item in b.getElementsByTagName('remap')]), minidom.parse('${CMAKE_SOURCE_DIR}/gen/compilers.xml').getElementsByTagName('compiler')))"

    OUTPUT_VARIABLE compiler_lines OUTPUT_STRIP_TRAILING_WHITESPACE
)

foreach(thing ${compiler_lines})
    string(REGEX REPLACE "," ";" thing_list ${thing})
    list(FIND thing_list ${COMPILER_NAME} check_val)
    if(NOT ("${check_val}" STREQUAL "-1"))
        string(REGEX REPLACE "${COMPILER_NAME}," ";" filter_string ${thing})
    endif()
endforeach()


#extract compiler prefixes from the xml file using abusive python
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c
    "from xml.dom import minidom; print ';'.join(map(lambda b: ','.join([','.join([b.attributes['name'].value,item.firstChild.data]) for item in b.getElementsByTagName('prefix')]), minidom.parse('${CMAKE_SOURCE_DIR}/gen/compilers.xml').getElementsByTagName('compiler')))"

    OUTPUT_VARIABLE compiler_prefixes OUTPUT_STRIP_TRAILING_WHITESPACE
)

foreach(thing ${compiler_prefixes})
    string(REGEX REPLACE "," ";" thing_list ${thing})
    list(FIND thing_list ${COMPILER_NAME} check_val)
    if(NOT ("${check_val}" STREQUAL "-1"))
        list(GET thing_list "1" prefix)
    endif()
endforeach()




#extract the arch lines from the xml file using abusive python
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c
    "from xml.dom import minidom; print ';'.join(map(lambda a: '%s %s %s %s'%(a.attributes['name'].value,a.getElementsByTagName('flag')[0].firstChild.data,a.getElementsByTagName('overrule')[0].firstChild.data,a.getElementsByTagName('overrule_val')[0].firstChild.data) if (len(a.getElementsByTagName('overrule'))) else '%s %s %s %s'%(a.attributes['name'].value,a.getElementsByTagName('flag')[0].firstChild.data,'no_overrule', 'no_overrule_val'), minidom.parse('${CMAKE_SOURCE_DIR}/gen/archs.xml').getElementsByTagName('arch')))"

    OUTPUT_VARIABLE arch_lines OUTPUT_STRIP_TRAILING_WHITESPACE
)




#set the various overrule values (see archs.xml)
#a lot of this is translating between automake and cmake
if(NOT "${CROSSCOMPILE_MULTILIB}" STREQUAL "true")
    set(MD_SUBCPU ${CMAKE_SYSTEM_PROCESSOR})
    #detect 32 or 64 bit compiler
    if(MD_SUBCPU MATCHES "^(i.86|x86|x86_64|amd64)$")
        include(CheckTypeSize)
        check_type_size("void*" SIZEOF_VOID_P BUILTIN_TYPES_ONLY)
        if (${SIZEOF_VOID_P} EQUAL 8)
            set(MD_SUBCPU x86_64)
        else()
            set(MD_SUBCPU x86)
        endif()
    endif()
endif()
if(NOT "${ORC_FOUND}" STREQUAL "TRUE")
    set(LV_HAVE_ORC "no")
endif()






macro(compiler_filter name flag)
    set(filtered_flag ${flag})
    foreach(thing ${filter_string})
        string(REGEX REPLACE "," ";" flagmap ${thing})
        list(GET flagmap "0" key)
        list(GET flagmap "1" val)
        string(REGEX MATCH "^${key}$" found ${flag})
        if("${found}" STREQUAL "${key}")
            string(REGEX REPLACE "^${key}$" "${val}" filtered_flag ${flag})
        endif()
    endforeach()
    set(${name}_flag "${prefix}${filtered_flag}")
endmacro()







macro(handle_arch name flag overrule overrule_val)

    #handle overrule
    if("${${overrule}}" STREQUAL "${overrule_val}")
        set(have_${name} FALSE)
        message(STATUS "${name} overruled")
    #handle special case for none flag
    elseif(${flag} STREQUAL "none")
        set(have_${name} TRUE)
    #otherwise test the flag(s) against the compiler
    else()
        include(CheckCXXCompilerFlag)
        string(REGEX REPLACE "," ";" flag_list ${flag})
        set(have_${name} 1)
        foreach(thing ${flag_list})
            compiler_filter(${name} ${thing})
            CHECK_CXX_COMPILER_FLAG(${${name}_flag} have_${thing})
            if(NOT (${have_${name}} AND ("${have_${thing}}" STREQUAL "1")))
                set(have_${name} 0)
            endif()
        endforeach()
    endif()

    if(have_${name})
        list(APPEND available_arches ${name})
    endif()

endmacro(handle_arch)

#create a list of available arches
foreach(arch_line ${arch_lines})
    string(REPLACE " " ";" args "${arch_line}")
    handle_arch(${args})
endforeach(arch_line)

message(STATUS "Available arches: ${available_arches}")

########################################################################
# Parse the machines xml file:
#  Test each machine to see if its arch dependencies are supported.
#  Build a list of supported machines and the machine definitions.
########################################################################
#extract the machine lines from the xml file using crazy python
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c
    "from xml.dom import minidom; print ';'.join(map(lambda a: '%s %s'%(a.attributes['name'].value,a.getElementsByTagName('archs')[0].firstChild.data),minidom.parse('${CMAKE_SOURCE_DIR}/gen/machines.xml').getElementsByTagName('machine')))"
    OUTPUT_VARIABLE machine_lines OUTPUT_STRIP_TRAILING_WHITESPACE
)

macro(handle_machine1 name)
    unset(machine_flags)
    string(TOUPPER LV_MACHINE_${name} machine_def)

    #check if all the arches are supported
    foreach(arch ${ARGN})
        set(is_match ${have_${arch}})
        if(NOT is_match)
            set(is_match FALSE)
            break()
        endif(NOT is_match)
        set(machine_flags "${machine_flags} ${${arch}_flag}")
    endforeach(arch)

    string(REGEX REPLACE "^[ \t]+" "" machine_flags "${machine_flags}")

    if(is_match)
        #this is a match, append the source and set its flags
        set(machine_source ${CMAKE_CURRENT_BINARY_DIR}/volk_machine_${name}.c)
        set_source_files_properties(${machine_source} PROPERTIES COMPILE_FLAGS "${machine_flags}")
        list(APPEND machine_sources ${machine_source})
        list(APPEND machine_defs ${machine_def})
        list(APPEND available_machines ${name})
    endif()
endmacro(handle_machine1)

macro(handle_machine name)
    set(arches ${ARGN})
    list(FIND arches "32|64" index)
    if(${index} EQUAL -1)
        handle_machine1(${name} ${arches})
    else()
        list(REMOVE_ITEM arches "32|64")
        handle_machine1(${name}_32 32 ${arches})
        handle_machine1(${name}_64 64 ${arches})
    endif()
endmacro(handle_machine)

#setup the available machines
foreach(machine_line ${machine_lines})
    string(REPLACE " " ";" args "${machine_line}")
    handle_machine(${args})
endforeach(machine_line)

message(STATUS "Available machines: ${available_machines}")

########################################################################
# Create rules to run the volk generator
########################################################################
#list of the generated sources
set(volk_gen_sources
    ${CMAKE_BINARY_DIR}/include/volk/volk.h
    ${CMAKE_BINARY_DIR}/lib/volk.c
    ${CMAKE_BINARY_DIR}/lib/volk_init.h
    ${CMAKE_BINARY_DIR}/include/volk/volk_typedefs.h
    ${CMAKE_BINARY_DIR}/include/volk/volk_cpu.h
    ${CMAKE_BINARY_DIR}/lib/volk_cpu.c
    ${CMAKE_BINARY_DIR}/include/volk/volk_config_fixed.h
    ${CMAKE_BINARY_DIR}/lib/volk_environment_init.c
    ${CMAKE_BINARY_DIR}/lib/volk_environment_init.h
    ${CMAKE_BINARY_DIR}/lib/volk_machines.h
    ${CMAKE_BINARY_DIR}/lib/volk_machines.c
    ${machine_sources}
)

#dependencies are all python, xml, and header implementation files
file(GLOB xml_files ${CMAKE_SOURCE_DIR}/gen/*.xml)
file(GLOB py_files ${CMAKE_SOURCE_DIR}/gen/*.py)
file(GLOB h_files ${CMAKE_SOURCE_DIR}/include/volk/*.h)

add_custom_command(
    OUTPUT ${volk_gen_sources}
    DEPENDS ${xml_files} ${py_files} ${h_files}
    COMMAND ${PYTHON_EXECUTABLE} -B
        ${CMAKE_SOURCE_DIR}/gen/volk_register.py
        ${CMAKE_BINARY_DIR}
)

########################################################################
# Handle orc support
########################################################################





if(ORC_FOUND)
    #setup orc library usage
    include_directories(${ORC_INCLUDE_DIRS})
    link_directories(${ORC_LIBRARY_DIRS})
    add_definitions(-DLV_HAVE_ORC)

    #setup orc functions
    file(GLOB orc_files ${CMAKE_SOURCE_DIR}/orc/*.orc)
    foreach(orc_file ${orc_files})

        #extract the name for the generated c source from the orc file
        get_filename_component(orc_file_name_we ${orc_file} NAME_WE)
        set(orcc_gen ${CMAKE_CURRENT_BINARY_DIR}/${orc_file_name_we}.c)

        #create a rule to generate the source and add to the list of sources
        add_custom_command(
            COMMAND ${ORCC_EXECUTABLE} --include math.h --implementation -o ${orcc_gen} ${orc_file}
            DEPENDS ${orc_file} OUTPUT ${orcc_gen}
        )
        list(APPEND volk_sources ${orcc_gen})

    endforeach(orc_file)
else()
    message(STATUS "Did not find liborc and orcc, disabling orc support...")
endif()

########################################################################
# Setup the volk sources list and library
########################################################################
if(NOT WIN32)
    add_definitions(-fvisibility=hidden)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

list(APPEND volk_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/volk_prefs.c
    ${CMAKE_CURRENT_SOURCE_DIR}/volk_rank_archs.c
    ${volk_gen_sources}
)

#set the machine definitions where applicable
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/volk.c
    ${CMAKE_CURRENT_BINARY_DIR}/volk_machines.c
PROPERTIES COMPILE_DEFINITIONS "${machine_defs}")

if(MSVC)
    #add compatibility includes for stdint types
    include_directories(${CMAKE_SOURCE_DIR}/msvc)
    #compile the sources as C++ due to the lack of complex.h under MSVC
    set_source_files_properties(${volk_sources} PROPERTIES LANGUAGE CXX)
endif()

#create the volk runtime library
add_library(volk SHARED ${volk_sources})
if(ORC_FOUND)
    target_link_libraries(volk ${ORC_LIBRARIES})
endif(ORC_FOUND)
set_target_properties(volk PROPERTIES SOVERSION ${LIBVER})
set_target_properties(volk PROPERTIES DEFINE_SYMBOL "volk_EXPORTS")

install(TARGETS volk
    LIBRARY DESTINATION lib${LIB_SUFFIX} COMPONENT "volk_runtime" # .so file
    ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT "volk_devel"   # .lib file
    RUNTIME DESTINATION bin              COMPONENT "volk_runtime" # .dll file
)

=== gnuradio-core/src/lib/CMakeLists.txt ===
# Copyright 2010-2011 Free Software Foundation, Inc.
# 
# This file is part of GNU Radio
# 
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# Setup compatibility checks and defines
########################################################################
include(${CMAKE_CURRENT_SOURCE_DIR}/ConfigChecks.cmake)

########################################################################
# Include subdirs rather to populate to the sources lists.
########################################################################
GR_INCLUDE_SUBDIRECTORY(missing)
GR_INCLUDE_SUBDIRECTORY(runtime)
GR_INCLUDE_SUBDIRECTORY(filter)
GR_INCLUDE_SUBDIRECTORY(viterbi)
GR_INCLUDE_SUBDIRECTORY(general)
GR_INCLUDE_SUBDIRECTORY(gengen)
GR_INCLUDE_SUBDIRECTORY(reed-solomon)
GR_INCLUDE_SUBDIRECTORY(io)
GR_INCLUDE_SUBDIRECTORY(hier)

list(APPEND gnuradio_core_sources bug_work_around_6.cc)
list(APPEND test_gnuradio_core_sources bug_work_around_6.cc)

########################################################################
# Setup the include and linker paths
########################################################################
include_directories(${GNURADIO_CORE_INCLUDE_DIRS})

include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

add_definitions(${GSL_DEFINITIONS})
include_directories(${GSL_INCLUDE_DIRS})
link_directories(${GSL_LIBRARY_DIRS})

include_directories(${FFTW3F_INCLUDE_DIRS})
link_directories(${FFTW3F_LIBRARY_DIRS})

########################################################################
# Setup library
########################################################################
list(APPEND gnuradio_core_libs
    gruel
    ${Boost_LIBRARIES}
    ${GSL_LIBRARIES}
    ${FFTW3F_LIBRARIES}
)

#need to link with librt on ubuntu 11.10 for shm_*
if(LINUX)
    list(APPEND gnuradio_core_libs rt)
endif()

add_library(gnuradio-core SHARED ${gnuradio_core_sources})
target_link_libraries(gnuradio-core ${gnuradio_core_libs})
GR_LIBRARY_FOO(gnuradio-core RUNTIME_COMPONENT "core_runtime" DEVEL_COMPONENT "core_devel")
#avoid fftw and gsl link in dependent libraries:
set_target_properties(gnuradio-core PROPERTIES LINK_INTERFACE_LIBRARIES "gruel")

########################################################################
# Setup executables
########################################################################
add_executable(gnuradio-config-info gnuradio-config-info.cc)
target_link_libraries(gnuradio-config-info gnuradio-core ${Boost_LIBRARIES})
install(
    TARGETS gnuradio-config-info
    DESTINATION ${GR_RUNTIME_DIR}
    COMPONENT "core_runtime"
)

########################################################################
# Setup tests
########################################################################
if(ENABLE_TESTING)

include_directories(${CPPUNIT_INCLUDE_DIRS})
link_directories(${CPPUNIT_LIBRARY_DIRS})

add_library(test-gnuradio-core SHARED ${test_gnuradio_core_sources})
target_link_libraries(test-gnuradio-core gnuradio-core ${CPPUNIT_LIBRARIES} ${Boost_LIBRARIES})

endif(ENABLE_TESTING)

=== gnuradio-core/src/lib/general/CMakeLists.txt ===
# Copyright 2010-2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

########################################################################
# Handle the generated sine table
########################################################################
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sine_table.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gen_sine_table.py
    COMMAND ${PYTHON_EXECUTABLE}
        ${CMAKE_CURRENT_SOURCE_DIR}/gen_sine_table.py >
        ${CMAKE_CURRENT_BINARY_DIR}/sine_table.h
)

include(AddFileDependencies)
ADD_FILE_DEPENDENCIES(${CMAKE_CURRENT_SOURCE_DIR}/gr_fxpt.cc
    ${CMAKE_CURRENT_BINARY_DIR}/sine_table.h
)

########################################################################
# Handle the generated constants
########################################################################
execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
    "import time;print time.strftime('%a, %d %b %Y %H:%M:%S', time.gmtime())"
    OUTPUT_VARIABLE BUILD_DATE OUTPUT_STRIP_TRAILING_WHITESPACE
)
message(STATUS "Loading build date ${BUILD_DATE} into gr_constants...")

message(STATUS "Loading version ${VERSION} into gr_constants...")

file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/${GR_CONF_DIR}"     SYSCONFDIR)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/${GR_PKG_CONF_DIR}" GR_PREFSDIR)

#double escape for windows backslash path separators
string(REPLACE "\\" "\\\\" prefix ${prefix})
string(REPLACE "\\" "\\\\" SYSCONFDIR ${SYSCONFDIR})
string(REPLACE "\\" "\\\\" GR_PREFSDIR ${GR_PREFSDIR})

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_constants.cc.in
    ${CMAKE_CURRENT_BINARY_DIR}/gr_constants.cc
@ONLY)

list(APPEND gnuradio_core_sources ${CMAKE_CURRENT_BINARY_DIR}/gr_constants.cc)

########################################################################
# Append gnuradio-core library sources
########################################################################
list(APPEND gnuradio_core_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_circular_file.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_count_bits.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fast_atan2f.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fft_vcc_fftw.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fxpt.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_misc.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_random.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_reverse.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_add_const_ss_generic.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_char_to_float.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_control_loop.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_debugger_hook.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_fft.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_char.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_int.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_short.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_uchar.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_glfsr.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_interleaved_short_to_complex.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_int_to_float.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_short_to_float.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_uchar_to_float.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/malloc16.c
)

########################################################################
# Append gnuradio-core test sources
########################################################################
list(APPEND test_gnuradio_core_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_general.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_circular_file.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_cpm.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_firdes.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_fxpt.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_fxpt_nco.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_fxpt_vco.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gr_math.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/qa_gri_lfsr.cc
)

########################################################################
# Install runtime headers
########################################################################
install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_core_api.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_circular_file.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_constants.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_count_bits.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_expj.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fft_vcc_fftw.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fxpt.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fxpt_nco.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_fxpt_vco.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_log2_const.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_math.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_misc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_nco.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_random.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_reverse.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_simple_framer_sync.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_test_types.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_vco.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_add_const_ss.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc_cc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc_ff.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc2_cc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc2_ff.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_char_to_float.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_control_loop.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_debugger_hook.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_fft.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_char.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_int.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_short.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_float_to_uchar.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_lfsr.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_glfsr.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_interleaved_short_to_complex.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_lfsr_15_1_0.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_lfsr_32k.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_int_to_float.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_short_to_float.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_uchar_to_float.h
    ${CMAKE_CURRENT_SOURCE_DIR}/malloc16.h
    ${CMAKE_CURRENT_SOURCE_DIR}/random.h
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio
    COMPONENT "core_devel"
)

########################################################################
# Install swig headers
########################################################################
if(ENABLE_PYTHON)
install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/general.i
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_constants.i
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc_cc.i
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc_ff.i
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc2_cc.i
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_agc2_ff.i
    ${CMAKE_CURRENT_SOURCE_DIR}/gri_control_loop.i
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio/swig
    COMPONENT "core_swig"
)
endif(ENABLE_PYTHON)

########################################################################
# Handle triple-threat files that have cc, h, and i
########################################################################
set(gr_core_general_triple_threats
    complex_vec_test
    gr_additive_scrambler_bb
    gr_agc_cc
    gr_agc_ff
    gr_agc2_cc
    gr_agc2_ff
    gr_align_on_samplenumbers_ss
    gr_bin_statistics_f
    gr_bytes_to_syms
    gr_char_to_float
    gr_check_counting_s
    gr_check_lfsr_32k_s
    gr_complex_to_interleaved_short
    gr_complex_to_xxx
    gr_conjugate_cc
    gr_copy
    gr_cpfsk_bc
    gr_cpm
    gr_ctcss_squelch_ff
    gr_decode_ccsds_27_fb
    gr_diff_decoder_bb
    gr_diff_encoder_bb
    gr_diff_phasor_cc
    gr_dpll_bb
    gr_deinterleave
    gr_delay
    gr_encode_ccsds_27_bb
    gr_fake_channel_coder_pp
    gr_feedforward_agc_cc
    gr_feval
    gr_fft_vcc
    gr_fft_vfc
    gr_firdes
    gr_float_to_char
    gr_float_to_complex
    gr_float_to_int
    gr_float_to_short
    gr_float_to_uchar
    gr_fmdet_cf
    gr_frequency_modulator_fc
    gr_framer_sink_1
    gr_glfsr_source_b
    gr_glfsr_source_f
    gr_head
    gr_int_to_float
    gr_interleave
    gr_interleaved_short_to_complex
    gr_iqcomp_cc
    gr_keep_one_in_n
    gr_kludge_copy
    gr_lfsr_32k_source_s
    gr_map_bb
    gr_nlog10_ff
    gr_nop
    gr_null_sink
    gr_null_source
    gr_pa_2x2_phase_combiner
    gr_packet_sink
    gr_peak_detector2_fb
    gr_phase_modulator_fc
    gr_pll_carriertracking_cc
    gr_pll_freqdet_cf
    gr_pll_refout_cc
    gr_pn_correlator_cc
    gr_prefs
    gr_probe_avg_mag_sqrd_c
    gr_probe_avg_mag_sqrd_cf
    gr_probe_avg_mag_sqrd_f
    gr_probe_signal_f
    gr_pwr_squelch_cc
    gr_pwr_squelch_ff
    gr_quadrature_demod_cf
    gr_rail_ff
    gr_regenerate_bb
    gr_remez
    gr_rms_cf
    gr_rms_ff
    gr_repeat
    gr_short_to_float
    gr_simple_correlator
    gr_simple_framer
    gr_simple_squelch_cc
    gr_skiphead
    gr_squash_ff
    gr_squelch_base_cc
    gr_squelch_base_ff
    gr_stream_mux
    gr_stream_to_streams
    gr_stream_to_vector
    gr_streams_to_stream
    gr_streams_to_vector
    gr_stretch_ff
    gr_test
    gr_threshold_ff
    gr_throttle
    gr_transcendental
    gr_uchar_to_float
    gr_vco_f
    gr_vector_to_stream
    gr_vector_to_streams
    gr_unpack_k_bits_bb
    gr_wavelet_ff
    gr_wvps_ff
    gr_descrambler_bb
    gr_scrambler_bb
    gr_probe_mpsk_snr_c
    gr_probe_density_b
    gr_annotator_alltoall
    gr_annotator_1to1
    gr_burst_tagger
    gr_correlate_access_code_tag_bb
)

foreach(file_tt ${gr_core_general_triple_threats})
    list(APPEND gnuradio_core_sources ${CMAKE_CURRENT_SOURCE_DIR}/${file_tt}.cc)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${file_tt}.h DESTINATION ${GR_INCLUDE_DIR}/gnuradio COMPONENT "core_devel")
    if(ENABLE_PYTHON)
        install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${file_tt}.i DESTINATION ${GR_INCLUDE_DIR}/gnuradio/swig COMPONENT "core_swig")
    endif(ENABLE_PYTHON)
endforeach(file_tt ${gr_core_general_triple_threats})

=== gnuradio-core/src/lib/gengen/CMakeLists.txt ===
# Copyright 2010-2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

########################################################################
# This file included, use CMake directory variables
########################################################################

########################################################################
# generate the python helper script which calls into the build utils
########################################################################
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/generate_helper.py "
#!${PYTHON_EXECUTABLE}

import sys, os, re
sys.path.append('${GR_CORE_PYTHONPATH}')
os.environ['srcdir'] = '${CMAKE_CURRENT_SOURCE_DIR}'
os.chdir('${CMAKE_CURRENT_BINARY_DIR}')

if __name__ == '__main__':
    import build_utils
    root, inp = sys.argv[1:3]
    for sig in sys.argv[3:]:
        name = re.sub ('X+', sig, root)
        d = build_utils.standard_dict(name, sig)
        build_utils.expand_template(d, inp)

")

########################################################################
# generation helper macro to generate various files from template
########################################################################
macro(expand_h_cc_i root)

    foreach(ext h cc i)
        #make a list of all the generated files
        unset(expanded_files_${ext})
        foreach(sig ${ARGN})
            string(REGEX REPLACE "X+" ${sig} name ${root})
            list(APPEND expanded_files_${ext} ${CMAKE_CURRENT_BINARY_DIR}/${name}.${ext})
        endforeach(sig)

        #create a command to generate the files
        add_custom_command(
            OUTPUT ${expanded_files_${ext}}
            DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${root}.${ext}.t
            COMMAND ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
                ${CMAKE_CURRENT_BINARY_DIR}/generate_helper.py
                ${root} ${root}.${ext}.t ${ARGN}
        )
    endforeach(ext)

    #make source files depends on headers to force generation
    set_source_files_properties(${expanded_files_cc}
        PROPERTIES OBJECT_DEPENDS "${expanded_files_h}"
    )

    #install rules for the generated cc, h, and i files
    list(APPEND generated_gengen_sources ${expanded_files_cc})
    list(APPEND generated_gengen_includes ${expanded_files_h})
    list(APPEND generated_gengen_swigs ${expanded_files_i})

endmacro(expand_h_cc_i)

########################################################################
# Invoke macro to generate various sources
########################################################################
expand_h_cc_i(gr_vector_source_X   b s i f c)
expand_h_cc_i(gr_vector_sink_X     b s i f c)
expand_h_cc_i(gr_noise_source_X      s i f c)
expand_h_cc_i(gr_sig_source_X        s i f c)

expand_h_cc_i(gr_add_const_XX           ss ii ff cc sf)
expand_h_cc_i(gr_multiply_const_XX      ss ii ff cc)
expand_h_cc_i(gr_add_XX                 ss ii ff cc)
expand_h_cc_i(gr_sub_XX                 ss ii ff cc)
expand_h_cc_i(gr_multiply_XX            ss ii ff cc)
expand_h_cc_i(gr_divide_XX              ss ii ff cc)
expand_h_cc_i(gr_mute_XX                ss ii ff cc)
expand_h_cc_i(gr_add_const_vXX          ss ii ff cc)
expand_h_cc_i(gr_multiply_const_vXX     ss ii ff cc)
expand_h_cc_i(gr_integrate_XX           ss ii ff cc)
expand_h_cc_i(gr_moving_average_XX      ss ii ff cc)

expand_h_cc_i(gr_chunks_to_symbols_XX         bf bc sf sc if ic)
expand_h_cc_i(gr_unpacked_to_packed_XX        bb ss ii)
expand_h_cc_i(gr_packed_to_unpacked_XX        bb ss ii)
expand_h_cc_i(gr_xor_XX                       bb ss ii)
expand_h_cc_i(gr_and_XX                       bb ss ii)
expand_h_cc_i(gr_and_const_XX                 bb ss ii)
expand_h_cc_i(gr_or_XX                        bb ss ii)
expand_h_cc_i(gr_not_XX                       bb ss ii)
expand_h_cc_i(gr_sample_and_hold_XX           bb ss ii ff)
expand_h_cc_i(gr_argmax_XX                    fs is ss)
expand_h_cc_i(gr_max_XX                       ff ii ss)
expand_h_cc_i(gr_peak_detector_XX             fb ib sb)

add_custom_target(gengen_generated DEPENDS
    ${generated_gengen_includes}
    ${generated_gengen_swigs}
)

########################################################################
# Create the master gengen swig include files
########################################################################
set(generated_index ${CMAKE_CURRENT_BINARY_DIR}/gengen_generated.i.in)
file(WRITE ${generated_index} "
//
// This file is machine generated.  All edits will be overwritten
//
")

file(APPEND ${generated_index} "%{\n")
foreach(swig_file ${generated_gengen_swigs})
    get_filename_component(name ${swig_file} NAME_WE)
    file(APPEND ${generated_index} "#include<${name}.h>\n")
endforeach(swig_file)
file(APPEND ${generated_index} "%}\n")

foreach(swig_file ${generated_gengen_swigs})
    get_filename_component(name ${swig_file} NAME)
    file(APPEND ${generated_index} "%include<${name}>\n")
endforeach(swig_file)

execute_process(
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${generated_index} ${CMAKE_CURRENT_BINARY_DIR}/gengen_generated.i
)

########################################################################
# Handle the generated sources + a few non-generated ones
########################################################################
list(APPEND gnuradio_core_sources
    ${generated_gengen_sources}
)

install(FILES
    ${generated_gengen_includes}
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_endianness.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_noise_type.h
    ${CMAKE_CURRENT_SOURCE_DIR}/gr_sig_source_waveform.h
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio
    COMPONENT "core_devel"
)

if(ENABLE_PYTHON)
    install(FILES
        ${generated_gengen_swigs}
        ${CMAKE_CURRENT_SOURCE_DIR}/gr_endianness.i
        ${CMAKE_CURRENT_SOURCE_DIR}/gengen.i
        ${CMAKE_CURRENT_BINARY_DIR}/gengen_generated.i
        DESTINATION ${GR_INCLUDE_DIR}/gnuradio/swig
        COMPONENT "core_swig"
    )
endif(ENABLE_PYTHON)

=== debian/changelog ===
gnuradio (3.5.1-1) unstable; urgency=low

  * new upstream version, re-packaged from scratch with modern tools
	    closes: #642716, #645332, #394849, #616832, #590048, #642580,
	    #647018, #557050, #559640, #631863
  * CMake build

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 26 Feb 2012 21:26:16 -0500

gnuradio (3.4.1-1) unstable; urgency=low

  * New upstream release
  * comedi: fix to use comedi 0.8 API
  * support for the Ettus UHD interface
  * deprecating libusrp and libusrp2

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 28 Sep 2011 02:13:45 -0000

gnuradio (3.3.0.dfsg-1) UNRELEASED; urgency=low

  * new upstream version
  * add Vcs entries to the control file
  * use maintainer-clean target, always run bootstrap before configure
  * switch from using python-central to dh_python2
  * switch to doxygen-latex as a build dep, closes: #616252

 -- Bdale Garbee <bdale@gag.com>  Fri, 04 Mar 2011 08:33:04 -0700

gnuradio (3.2.2.dfsg-2) unstable; urgency=low

  * fix typos in short package descriptions, closes: #556572
  * resolve gnuradio-companion conflict with grc by renaming our binary,
    closes: #557050
  * accept patches that remove moc files and make libusrp packages depend
    on adduser, closes: #566564, #566565, #574209, #574231, #574209
  * stop delivering custom prefs.py, closes: #559640
  * lose the conflicts on python-wxgtk2.6, closes: #582486

 -- Bdale Garbee <bdale@gag.com>  Tue, 08 Jun 2010 20:05:02 -0600

gnuradio (3.2.2.dfsg-1) unstable; urgency=low

  * new upstream version, includes gcc4.3 support, closes: #474801, #524387
  * upstream tarball modified to elide unnecessary Altera-licensed files
  * merge debian/ content restructuring from upstream svn
  * change build-dep from fftw3-dev to libfftw3-dev, closes: #458231
  * fix problem with rebuilding, closes: #441739
  * no longer need to move to contrib now that sdcc is fully back in main,
    we just need to build depend on sdcc 2.9.0 or later, closes: #457402
  * rebuild reflects python-central file location change, closes: #490513
  * change Jack build depend to libjack-dev, closes: #527413

 -- Bdale Garbee <bdale@gag.com>  Sun, 01 Nov 2009 15:13:54 -0700

gnuradio (3.0.4-2) unstable; urgency=high

  * rebuild with new version number and upload to finally (?) recover from
    over-zealous removal in response to bug 453154
  * recommend udev instead of hotplug, closes: #448907

 -- Bdale Garbee <bdale@gag.com>  Sun, 23 Dec 2007 12:11:49 -0700

gnuradio (3.0.4-1) unstable; urgency=low

  * new upstream version
  * fix build failure with gcc-4.3 by adding a #include, closes: #420896

 -- Bdale Garbee <bdale@gag.com>  Tue, 14 Aug 2007 22:38:32 -0600

gnuradio (3.0.3-1) unstable; urgency=low

  * new upstream version
  * tweak gnuradio-doc package to eliminate spurious subdirectory level
  * add a usrp-doc binary package, recommended by the usrp package, and
    include xmlto in build dependencies so usrp_guide.html gets generated,
    closes: #407368

 -- Bdale Garbee <bdale@gag.com>  Sun, 11 Mar 2007 23:55:32 -0600

gnuradio (3.0.2-2) unstable; urgency=high

  * add run-time dependency on python-wxgtk2.6.  leaving urgency high since
    this would be a silly bug to release etch with if we can avoid it.

 -- Bdale Garbee <bdale@gag.com>  Mon,  4 Dec 2006 15:35:53 -0700

gnuradio (3.0.2-1) unstable; urgency=high

  * new upstream version, fixes FTBFS issues

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Nov 2006 14:52:33 -0800

gnuradio (3.0-3) unstable; urgency=high

  * put python-all-dev back in the build-depends list, closes: #398246
  * move gr-wxgui conflicts/depends to python-gnuradio, closes: #396302
  * fix up sections in control to match overrides

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Nov 2006 10:59:58 -0800

gnuradio (3.0-2) unstable; urgency=high

  * reworked package dependencies so that the 'gnuradio' binary package no
    longer depends on the pieces in contrib.  instead, the 'usrp' binary
    package in contrib now depends on all the USRP-related pieces.  A user
    who doesn't have a USRP board can just install 'gnuradio' and get all
    the relevant pieces, a USRP user needs to install both 'gnuradio' and
    'usrp'.  Closes: #394533
  * improve consistency of references to 'GNU Radio' as upstream project name
  * make the gnuradio package dependencies on python-gnuradio and python-usrp
    be version specific on suggestion from Ramakrishnan Muthukrishnan

 -- Bdale Garbee <bdale@gag.com>  Fri, 10 Nov 2006 00:39:38 -0800

gnuradio (3.0-1) unstable; urgency=low

  * new maintainer, new upstream version
  * Restructuring source and binary packages to follow upstream changes, more
    or less repackaging from scratch taking ideas from the previous packaging
    by Ramakrishnan Muthukrishnan and Steinar H. Gunderson.  This single
    source package replaces all of:
        gnuradio-core
        gnuradio-examples
        gr-audio-alsa
        gr-audio-jack
        gr-audio-oss
        gr-usrp
        gr-wxgui
        usrp
    In addition, the 'gnuradio' binary package is a new meta-package that
    conveniently depends on everything gnuradio related to ease installation.

 -- Bdale Garbee <bdale@gag.com>  Sun,  8 Oct 2006 13:28:21 -0600

=== debian/control ===
################################################################################
# Single source deb for entire distribution                                    #
################################################################################

Source: gnuradio
Section: comm
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Conflicts: automake1.8, automake1.9
Build-Depends: debhelper (>= 8.0.0~), cmake, libuhd-dev, libaudio-dev, libxi-dev, libfontconfig1-dev, libxrender-dev, libpulse-dev, libcomedi-dev, swig (>=1.3.31), python-dev, libfftw3-dev, libcppunit-dev (>=1.9.14), libboost-all-dev (>=1.35), libsdl1.2-dev, python-wxgtk2.8, guile-1.8-dev, libqt4-dev, python-numpy, python-opengl, libgsl0-dev (>=1.10), python-cheetah, python-lxml, doxygen, xmlto, qt4-dev-tools, libqwt5-qt4-dev, libqwtplot3d-qt4-dev, pyqt4-dev-tools, python-qwt5-qt4, python-gtk2-dev, pkg-config (>=0.15.0)
Standards-Version: 3.9.3
Vcs-Git: git://anonscm.debian.org/users/bottoms/pkg-gnuradio.git
Vcs-Browser: http://anonscm.debian.org/git/users/bottoms/pkg-gnuradio.git
X-Python-Version: =2.7

################################################################################
# Multiple library packages
################################################################################

Package: gnuradio
Architecture: any
Depends: ${python:Depends}, python-wxgtk2.8, python-cheetah, adduser, ${shlibs:Depends}, ${misc:Depends}
Recommends: python-qt4, python-qwt5-qt4, python-scipy, python-matplotlib, uhd-images, python-tk
Description: GNU Radio Software Radio Toolkit
 GNU Radio provides signal processing blocks to implement software
 radios. It can be used with readily-available low-cost external RF
 hardware to create software-defined radios, or without hardware in a
 simulation-like environment. It is widely used in hobbyist, academic
 and commercial environments to support both wireless communications
 research and real-world radio systems.
 .
 GNU Radio applications are primarily written using the Python
 programming language, while the supplied performance-critical signal
 processing path is implemented in C++ using processor floating-point
 extensions, where available. Thus, the developer is able to implement
 real-time, high-throughput radio systems in a simple-to-use,
 rapid-application-development environment.
 .
 While not primarily a simulation tool, GNU Radio does support
 development of signal processing algorithms using pre-recorded or
 generated data, avoiding the need for actual RF hardware.
 .
 This package contains the gnuradio-companion, a graphical tool for
 creating signal flow graphs and generating flow-graph source code.
 Also included are a variety of tools and utility programs.

Package: gnuradio-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: GNU Software Defined Radio toolkit documentation
 Documentation for the GNU Radio software defined radio system
 in html and xml form.

Package: gnuradio-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Description: GNU Software Defined Radio toolkit development
 Header files for the GNU Radio software defined radio system.

Package: libgnuradio
Section: libs
Architecture: all
Depends: ${misc:Depends}, libgnuradio-atsc3.5.1, libgnuradio-audio3.5.1, libgnuradio-comedi3.5.1, libgnuradio-core3.5.1, libgnuradio-digital3.5.1, libgnuradio-noaa3.5.1, libgnuradio-pager3.5.1, libgnuradio-qtgui3.5.1, libgnuradio-trellis3.5.1, libgnuradio-uhd3.5.1, libgnuradio-video-sdl3.5.1, libgnuradio-vocoder3.5.1, libgruel3.5.1, libvolk0.0.0
Description: Dummy package for gnuradio libraries
 Fourteen libraries are built with gnuradio.
 This is a virtual package selecting all of them.

Package: libgnuradio-atsc3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio atsc functions
 Library for handling ATSC (Advanced Television Systems Committee)
 signals such as those used for digital television broadcast in North
 America. Part of the main gnuradio build.

Package: libgnuradio-audio3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio audio functions
 This is the gr-audio library, used to connect to audio sources
 (mic-in) and sinks (speaker-out) ports on a computer. The underlying
 hardware driver is system and OS dependent and this module should
 automatically discover the correct one to use.  Part of the main
 gnuradio build.

Package: libgnuradio-comedi3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio comedi instrument control functions
 Allows gnuradio to use signals from data acquisition hardware
 supported by the Comedi library and drivers.
 Part of the main gnuradio build.

Package: libgnuradio-core3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio core functions
 Core signal processing math and process scheduling library.
 Part of the main gnuradio build.

Package: libgnuradio-digital3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio digital communications functions
 All the functions for doing digital modulation and demodulation,
 including bpsk, qpsk, gmsk and ofdm signals.
 Part of the main gnuradio build.

Package: libgnuradio-noaa3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio noaa satellite signals functions
 Library for handling NOAA HRPT (National Oceanic and Atmospheric
 Administration High Rate Picture Transmission) signals.
 Part of the main gnuradio build.

Package: libgnuradio-pager3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio pager radio functions
 Library for handling pager signals, including FLEX protocol data.
 Part of the main gnuradio build.

Package: libgnuradio-qtgui3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio Qt graphical user interface functions
 QT-based graphical sinks for gnuradio applications.
 Part of the main gnuradio build.

Package: libgnuradio-trellis3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio trellis modulation functions
 Library for trellis coding modulation, including the Vitterbi
 Algorithm. Part of the main gnuradio build.

Package: libgnuradio-uhd3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio universal hardware driver functions
 The gnuradio interface to the UHD library to connect to and send and
 receive data between to the Ettus Research, LLC product line -
 including the USRP family of software radio periphal devices.
 Part of the main gnuradio build.

Package: libgnuradio-video-sdl3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio video functions
 Library for handling SDL (Simple DirectMedia Layer) video data.
 Part of the main gnuradio build.

Package: libgnuradio-vocoder3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio vocoder functions
 Library of vocoder blocks, including ulaw, alaw, gsm and codec2.
 Part of the main gnuradio build.

Package: libgruel3.5.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio utilities etcetera functions
 The GNU Radio Utility Etcetera Library, a collection of low-level
 routines to avoid dependencies on the full GNU Radio core or other
 libraries. Part of the main gnuradio build.

Package: libvolk0.0.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gnuradio vector optimized functions
 Vector-Optimized Library of Kernels) and it is designed to help
 gnuradio work with the processor's SIMD instruction sets. These are
 very powerful vector operations that can give signal processing a
 huge boost in performance. Part of the main gnuradio build.
